// shushObservers.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"


BZ_GET_PLUGIN_VERSION


//============================================================================//

class ShushHandler : public bz_EventHandler
{
  public:
    void process(bz_EventData* eventData);
};


static ShushHandler shushHandler;


void ShushHandler::process(bz_EventData* eventData)
{
  if (eventData->eventType != bz_eChatMessageEvent) {
    return;
  }

  if (!bz_isCountDownActive() && !bz_isCountDownInProgress()) {
    return; // not in a game
  }

  bz_ChatEventData* chatData = (bz_ChatEventData*)eventData;
  if (chatData->to != BZ_ALLUSERS) {
    return; // not a public chat message
  }

  bz_PlayerRecord* player = bz_getPlayerByIndex(chatData->from);
  if (player == NULL) {
    return; // not a recognized observer
  }

  if (player->team == eObservers) {
    // squelch the original message, and send the violator a warning
    chatData->message = "";
    bz_sendTextMessage(BZ_SERVER, chatData->from,
                       "Shush, players are trying to play");
  }

  bz_freePlayerRecord(player);
}


//============================================================================//

BZF_PLUGIN_CALL int bz_Load(const char* /*cmdLine*/)
{
  bz_registerEvent(bz_eChatMessageEvent, &shushHandler);
  bz_debugMessage(4, "shushObservers plugin loaded");
  return 0;
}


BZF_PLUGIN_CALL int bz_Unload()
{
  bz_removeEvent(bz_eChatMessageEvent, &shushHandler);
  bz_debugMessage(4, "shushObservers plugin unloaded");
  return 0;
}


//============================================================================//


// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8

